/*
 * This file was generated automatically by ExtUtils::ParseXS version 3.39 from the
 * contents of Collator.xs. Do not edit this file, edit Collator.xs instead.
 *
 *    ANY CHANGES MADE HERE WILL BE LOST!
 *
 */

#line 1 "Collator.xs"
#include "EXTERN.h"
#include "perl.h"
#include "XSUB.h"
#include "unicode/ucol.h"

#include "const-c.inc"

typedef UCollator *Unicode__ICU__Collator;

/* iterators require all of these, but most aren't called for our
 * use-cases */


static int32_t
byte_getIndex(UCharIterator *i, UCharIteratorOrigin origin) {
  switch(origin) {
  case UITER_START:
    return 0;
  case UITER_CURRENT:
    return i->index;
  case UITER_LIMIT:
    return i->length;
  case UITER_ZERO:
    return 0;
  case UITER_LENGTH:
    return i->length;
  }
}

static int32_t
byte_move(UCharIterator *i, int32_t delta, UCharIteratorOrigin origin) {
  int32_t index = 0;
  switch(origin) {
  case UITER_START:
    index = delta;
    break;
  case UITER_CURRENT:
    index = i->index + delta;
    break;
  case UITER_LIMIT:
    index = i->length + delta;
    break;
  case UITER_ZERO:
    index = delta;
    break;
  case UITER_LENGTH:
    index = i->length + delta;
    break;
  }

  if (index >= 0 && index <= i->length)
    i->index = index;
}

static UBool
byte_hasNext(UCharIterator *i) {
  return i->index < i->length;
}

static UBool
byte_hasPrevious(UCharIterator *i) {
  return i->index > 0;
}

UChar32
byte_current(UCharIterator *i) {
  if(i->index < i->length) {
    unsigned const char *p = i->context;
    return p[i->index];
  }
  return U_SENTINEL;
}

UChar32
byte_next(UCharIterator *i) {
  if(i->index < i->length) {
    unsigned const char *p = i->context;
    return p[i->index++];
  }
  return U_SENTINEL;
}

UChar32
byte_previous(UCharIterator *i) {
  if (i->index > 0) {
    unsigned const char *p = i->context;
    return p[--(i->index)];
  }
  return U_SENTINEL;
}

uint32_t
byte_getState(const UCharIterator *i) {
  return i->index;
}

void
byte_setState(UCharIterator *i, uint32_t state, UErrorCode *status) {
  if (state > i->length) {
    *status = U_INDEX_OUTOFBOUNDS_ERROR;
  }
  else {
    i->index = state;
  }
}

/* Character iterator for byte strings */
static void
uiter_setByteString(UCharIterator *c, char const *src, size_t len) {
  c->context = src;
  c->length = len;
  c->start = 0;
  c->index = 0;
  c->limit = len;
  c->getIndex = byte_getIndex;
  c->move = byte_move;
  c->hasNext = byte_hasNext;
  c->hasPrevious = byte_hasPrevious;
  c->current = byte_current;
  c->next = byte_next;
  c->previous = byte_previous;
  c->getState = byte_getState;
  c->setState = byte_setState;
}

static void *
malloc_temp(pTHX_ size_t size) {
  SV *sv = sv_2mortal(newSV(size));

  return SvPVX(sv);
}

static UChar *
make_uchar(pTHX_ SV *sv, STRLEN *lenp) {
  STRLEN len;
  /* SvPV early to process any GMAGIC */
  char const *pv = SvPV(sv, len);

  if (SvUTF8(sv)) {
    /* room for the characters and a bit for UTF-16 */
    STRLEN src_chars = sv_len_utf8(sv);
    int32_t cap = src_chars * 5 / 4 + 10;
    size_t size = sizeof(UChar) * cap;
    SV *result_sv = sv_2mortal(newSV(size));
    UChar *result = (UChar *)SvPVX(result_sv);
    int32_t result_len;
    UErrorCode status = U_ZERO_ERROR;

    u_strFromUTF8(result, cap, &result_len, pv, len, &status);

    if (status == U_BUFFER_OVERFLOW_ERROR
	|| result_len >= cap) {
      /* need more room, repeat */
      /* ideally this doesn't happen much */
      cap = result_len + 10;
      SvGROW(result_sv, sizeof(UChar) * cap);
      result = (UChar *)SvPVX(result_sv);
      status = U_ZERO_ERROR;
      u_strFromUTF8(result, cap, &result_len, pv, len, &status);
    }

    if (U_SUCCESS(status)) {
      *lenp = result_len;

      return result;
    }
    else {
      croak("Error converting utf8 to utf16: %d", status);
    }
  }
  else {
    UChar *result = malloc_temp(aTHX_ sizeof(UChar) * (len + 1));
    ssize_t i;
    for (i = 0; i < len; ++i)
      result[i] = (unsigned char)pv[i];
    result[len] = 0;
    *lenp = len;

    return result;
  }
}

/*

Convert a UChar * native ICU string into an SV.

Currently this always returns a string with UTF8 on, but that may change.

*/

static SV *
from_uchar(pTHX_ const UChar *src, int32_t len) {
  /* rough guess */
  STRLEN bytes = len * 2;
  SV *result = newSV(bytes);
  UErrorCode status = U_ZERO_ERROR;
  int32_t result_len = 0;

  u_strToUTF8(SvPVX(result), SvLEN(result), &result_len, src, len, &status);
  if (status == U_BUFFER_OVERFLOW_ERROR
      || result_len >= SvLEN(result)) {
    /* overflow of some sort, expand it */
    SvGROW(result, result_len + 10);
    status = U_ZERO_ERROR;
    u_strToUTF8(SvPVX(result), SvLEN(result), &result_len, src, len, &status);
  }

  SvCUR_set(result, result_len);
  SvPOK_only(result);
  *SvEND(result) = '\0';
  SvUTF8_on(result);

  return result;
}

static UCollationResult
ucol_cmp(pTHX_ UCollator *col, SV *sv1, SV *sv2) {
  UCollationResult result;
#if U_ICU_VERSION_MAJOR_NUM >= 50 && !defined(USE_ITERATORS)
  const char *s1, *s2;
  STRLEN len1, len2;
  UErrorCode status = U_ZERO_ERROR;

  s1 = SvPVutf8(sv1, len1);
  s2 = SvPVutf8(sv2, len2);

  result = ucol_strcollUTF8(col, s1, len1, s2, len2, &status);
#else
  UCharIterator c1, c2;
  const char *s1, *s2;
  STRLEN len1, len2;
  UErrorCode status = U_ZERO_ERROR;

  s1 = SvPV(sv1, len1);
  s2 = SvPV(sv2, len2);
  if (SvUTF8(sv1))
    uiter_setUTF8(&c1, s1, len1);
  else
    uiter_setByteString(&c1, s1, len1);
  if (SvUTF8(sv2))
    uiter_setUTF8(&c2, s2, len2);
  else
    uiter_setByteString(&c2, s2, len2);
  result = ucol_strcollIter(col, &c1, &c2, &status);
#endif

  if (!U_SUCCESS(status)) {
    croak("Error comparing: %d", (int)status);
  }

  return result;
}

#line 264 "Collator.c"
#ifndef PERL_UNUSED_VAR
#  define PERL_UNUSED_VAR(var) if (0) var = var
#endif

#ifndef dVAR
#  define dVAR		dNOOP
#endif


/* This stuff is not part of the API! You have been warned. */
#ifndef PERL_VERSION_DECIMAL
#  define PERL_VERSION_DECIMAL(r,v,s) (r*1000000 + v*1000 + s)
#endif
#ifndef PERL_DECIMAL_VERSION
#  define PERL_DECIMAL_VERSION \
	  PERL_VERSION_DECIMAL(PERL_REVISION,PERL_VERSION,PERL_SUBVERSION)
#endif
#ifndef PERL_VERSION_GE
#  define PERL_VERSION_GE(r,v,s) \
	  (PERL_DECIMAL_VERSION >= PERL_VERSION_DECIMAL(r,v,s))
#endif
#ifndef PERL_VERSION_LE
#  define PERL_VERSION_LE(r,v,s) \
	  (PERL_DECIMAL_VERSION <= PERL_VERSION_DECIMAL(r,v,s))
#endif

/* XS_INTERNAL is the explicit static-linkage variant of the default
 * XS macro.
 *
 * XS_EXTERNAL is the same as XS_INTERNAL except it does not include
 * "STATIC", ie. it exports XSUB symbols. You probably don't want that
 * for anything but the BOOT XSUB.
 *
 * See XSUB.h in core!
 */


/* TODO: This might be compatible further back than 5.10.0. */
#if PERL_VERSION_GE(5, 10, 0) && PERL_VERSION_LE(5, 15, 1)
#  undef XS_EXTERNAL
#  undef XS_INTERNAL
#  if defined(__CYGWIN__) && defined(USE_DYNAMIC_LOADING)
#    define XS_EXTERNAL(name) __declspec(dllexport) XSPROTO(name)
#    define XS_INTERNAL(name) STATIC XSPROTO(name)
#  endif
#  if defined(__SYMBIAN32__)
#    define XS_EXTERNAL(name) EXPORT_C XSPROTO(name)
#    define XS_INTERNAL(name) EXPORT_C STATIC XSPROTO(name)
#  endif
#  ifndef XS_EXTERNAL
#    if defined(HASATTRIBUTE_UNUSED) && !defined(__cplusplus)
#      define XS_EXTERNAL(name) void name(pTHX_ CV* cv __attribute__unused__)
#      define XS_INTERNAL(name) STATIC void name(pTHX_ CV* cv __attribute__unused__)
#    else
#      ifdef __cplusplus
#        define XS_EXTERNAL(name) extern "C" XSPROTO(name)
#        define XS_INTERNAL(name) static XSPROTO(name)
#      else
#        define XS_EXTERNAL(name) XSPROTO(name)
#        define XS_INTERNAL(name) STATIC XSPROTO(name)
#      endif
#    endif
#  endif
#endif

/* perl >= 5.10.0 && perl <= 5.15.1 */


/* The XS_EXTERNAL macro is used for functions that must not be static
 * like the boot XSUB of a module. If perl didn't have an XS_EXTERNAL
 * macro defined, the best we can do is assume XS is the same.
 * Dito for XS_INTERNAL.
 */
#ifndef XS_EXTERNAL
#  define XS_EXTERNAL(name) XS(name)
#endif
#ifndef XS_INTERNAL
#  define XS_INTERNAL(name) XS(name)
#endif

/* Now, finally, after all this mess, we want an ExtUtils::ParseXS
 * internal macro that we're free to redefine for varying linkage due
 * to the EXPORT_XSUB_SYMBOLS XS keyword. This is internal, use
 * XS_EXTERNAL(name) or XS_INTERNAL(name) in your code if you need to!
 */

#undef XS_EUPXS
#if defined(PERL_EUPXS_ALWAYS_EXPORT)
#  define XS_EUPXS(name) XS_EXTERNAL(name)
#else
   /* default to internal */
#  define XS_EUPXS(name) XS_INTERNAL(name)
#endif

#ifndef PERL_ARGS_ASSERT_CROAK_XS_USAGE
#define PERL_ARGS_ASSERT_CROAK_XS_USAGE assert(cv); assert(params)

/* prototype to pass -Wmissing-prototypes */
STATIC void
S_croak_xs_usage(const CV *const cv, const char *const params);

STATIC void
S_croak_xs_usage(const CV *const cv, const char *const params)
{
    const GV *const gv = CvGV(cv);

    PERL_ARGS_ASSERT_CROAK_XS_USAGE;

    if (gv) {
        const char *const gvname = GvNAME(gv);
        const HV *const stash = GvSTASH(gv);
        const char *const hvname = stash ? HvNAME(stash) : NULL;

        if (hvname)
	    Perl_croak_nocontext("Usage: %s::%s(%s)", hvname, gvname, params);
        else
	    Perl_croak_nocontext("Usage: %s(%s)", gvname, params);
    } else {
        /* Pants. I don't think that it should be possible to get here. */
	Perl_croak_nocontext("Usage: CODE(0x%" UVxf ")(%s)", PTR2UV(cv), params);
    }
}
#undef  PERL_ARGS_ASSERT_CROAK_XS_USAGE

#define croak_xs_usage        S_croak_xs_usage

#endif

/* NOTE: the prototype of newXSproto() is different in versions of perls,
 * so we define a portable version of newXSproto()
 */
#ifdef newXS_flags
#define newXSproto_portable(name, c_impl, file, proto) newXS_flags(name, c_impl, file, proto, 0)
#else
#define newXSproto_portable(name, c_impl, file, proto) (PL_Sv=(SV*)newXS(name, c_impl, file), sv_setpv(PL_Sv, proto), (CV*)PL_Sv)
#endif /* !defined(newXS_flags) */

#if PERL_VERSION_LE(5, 21, 5)
#  define newXS_deffile(a,b) Perl_newXS(aTHX_ a,b,file)
#else
#  define newXS_deffile(a,b) Perl_newXS_deffile(aTHX_ a,b)
#endif

#line 408 "Collator.c"

XS_EUPXS(XS_Unicode__ICU__Collator_new); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Unicode__ICU__Collator_new)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "class, loc");
    {
	const char *	loc = (const char *)SvPV_nolen(ST(1))
;
#line 262 "Collator.xs"
	UErrorCode status = U_ZERO_ERROR;
#line 421 "Collator.c"
	Unicode__ICU__Collator	RETVAL;
#line 264 "Collator.xs"
	RETVAL = ucol_open(loc, &status);
	if (!U_SUCCESS(status)) {
	    croak("Could not create collation for %s: %d", loc, (int)status);
	}
#line 428 "Collator.c"
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    sv_setref_pv(RETVALSV, "Unicode::ICU::Collator", (void*)RETVAL);
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Unicode__ICU__Collator_DESTROY); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Unicode__ICU__Collator_DESTROY)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "col");
    {
	Unicode__ICU__Collator	col;

	if (SvROK(ST(0))) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    col = INT2PTR(Unicode__ICU__Collator,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not a reference",
			"Unicode::ICU::Collator::DESTROY",
			"col")
;
#line 275 "Collator.xs"
	ucol_close(col);
#line 460 "Collator.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Unicode__ICU__Collator_cmp); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Unicode__ICU__Collator_cmp)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "col, sv1, sv2");
    {
	Unicode__ICU__Collator	col;
	SV *	sv1 = ST(1)
;
	SV *	sv2 = ST(2)
;
	int	RETVAL;
	dXSTARG;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Unicode::ICU::Collator")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    col = INT2PTR(Unicode__ICU__Collator,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"Unicode::ICU::Collator::cmp",
			"col", "Unicode::ICU::Collator")
;
#line 283 "Collator.xs"
        RETVAL = ucol_cmp(aTHX_ col, sv1, sv2);
#line 492 "Collator.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Unicode__ICU__Collator_eq); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Unicode__ICU__Collator_eq)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "col, sv1, sv2");
    {
	Unicode__ICU__Collator	col;
	SV *	sv1 = ST(1)
;
	SV *	sv2 = ST(2)
;
	bool	RETVAL;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Unicode::ICU::Collator")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    col = INT2PTR(Unicode__ICU__Collator,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"Unicode::ICU::Collator::eq",
			"col", "Unicode::ICU::Collator")
;
#line 293 "Collator.xs"
        RETVAL = ucol_cmp(aTHX_ col, sv1, sv2) == UCOL_EQUAL;
#line 524 "Collator.c"
	ST(0) = boolSV(RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Unicode__ICU__Collator_ne); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Unicode__ICU__Collator_ne)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "col, sv1, sv2");
    {
	Unicode__ICU__Collator	col;
	SV *	sv1 = ST(1)
;
	SV *	sv2 = ST(2)
;
	bool	RETVAL;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Unicode::ICU::Collator")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    col = INT2PTR(Unicode__ICU__Collator,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"Unicode::ICU::Collator::ne",
			"col", "Unicode::ICU::Collator")
;
#line 303 "Collator.xs"
        RETVAL = ucol_cmp(aTHX_ col, sv1, sv2) != UCOL_EQUAL;
#line 556 "Collator.c"
	ST(0) = boolSV(RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Unicode__ICU__Collator_gt); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Unicode__ICU__Collator_gt)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "col, sv1, sv2");
    {
	Unicode__ICU__Collator	col;
	SV *	sv1 = ST(1)
;
	SV *	sv2 = ST(2)
;
	bool	RETVAL;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Unicode::ICU::Collator")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    col = INT2PTR(Unicode__ICU__Collator,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"Unicode::ICU::Collator::gt",
			"col", "Unicode::ICU::Collator")
;
#line 313 "Collator.xs"
        RETVAL = ucol_cmp(aTHX_ col, sv1, sv2) == UCOL_GREATER;
#line 588 "Collator.c"
	ST(0) = boolSV(RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Unicode__ICU__Collator_lt); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Unicode__ICU__Collator_lt)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "col, sv1, sv2");
    {
	Unicode__ICU__Collator	col;
	SV *	sv1 = ST(1)
;
	SV *	sv2 = ST(2)
;
	bool	RETVAL;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Unicode::ICU::Collator")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    col = INT2PTR(Unicode__ICU__Collator,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"Unicode::ICU::Collator::lt",
			"col", "Unicode::ICU::Collator")
;
#line 323 "Collator.xs"
        RETVAL = ucol_cmp(aTHX_ col, sv1, sv2) == UCOL_LESS;
#line 620 "Collator.c"
	ST(0) = boolSV(RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Unicode__ICU__Collator_ge); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Unicode__ICU__Collator_ge)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "col, sv1, sv2");
    {
	Unicode__ICU__Collator	col;
	SV *	sv1 = ST(1)
;
	SV *	sv2 = ST(2)
;
	bool	RETVAL;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Unicode::ICU::Collator")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    col = INT2PTR(Unicode__ICU__Collator,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"Unicode::ICU::Collator::ge",
			"col", "Unicode::ICU::Collator")
;
#line 333 "Collator.xs"
        RETVAL = ucol_cmp(aTHX_ col, sv1, sv2) != UCOL_LESS;
#line 652 "Collator.c"
	ST(0) = boolSV(RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Unicode__ICU__Collator_le); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Unicode__ICU__Collator_le)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "col, sv1, sv2");
    {
	Unicode__ICU__Collator	col;
	SV *	sv1 = ST(1)
;
	SV *	sv2 = ST(2)
;
	bool	RETVAL;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Unicode::ICU::Collator")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    col = INT2PTR(Unicode__ICU__Collator,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"Unicode::ICU::Collator::le",
			"col", "Unicode::ICU::Collator")
;
#line 343 "Collator.xs"
        RETVAL = ucol_cmp(aTHX_ col, sv1, sv2) != UCOL_GREATER;
#line 684 "Collator.c"
	ST(0) = boolSV(RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Unicode__ICU__Collator_getSortKey); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Unicode__ICU__Collator_getSortKey)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "col, sv");
    {
	Unicode__ICU__Collator	col;
	SV *	sv = ST(1)
;
#line 352 "Collator.xs"
	/* freed by FREETMPS */
        UChar *u16text;
	STRLEN len;
        size_t alloc;
	SV *result_sv;
	uint8_t *result;
	int32_t rlen;
#line 709 "Collator.c"
	SV *	RETVAL;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Unicode::ICU::Collator")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    col = INT2PTR(Unicode__ICU__Collator,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"Unicode::ICU::Collator::getSortKey",
			"col", "Unicode::ICU::Collator")
;
#line 360 "Collator.xs"
	u16text = make_uchar(aTHX_ sv, &len);
	alloc = len * 3 + 2;
	result_sv = newSV(alloc);
	result = (uint8_t*)SvPVX(result_sv);
	/* sometimes it allocates a bit more */
	alloc = SvLEN(result_sv);
	rlen = ucol_getSortKey(col, u16text, len, result, alloc);
	if (rlen == 0)
  	    croak("Internal error in ucol_getSortKey");

	if (rlen > SvLEN(result_sv)) {
	  /* ideally we don't execute this often */
	  int32_t new_len = rlen + 10;
	  /* expand the buffer and try again */
	  SvGROW(result_sv, new_len);
	  result = (uint8_t*)SvPVX(result_sv);
	  new_len = SvLEN(result_sv);
	  rlen = ucol_getSortKey(col, u16text, len, result, new_len);
	}
	/* the result length includes the trailing NUL */
        SvCUR_set(result_sv, rlen-1);
	/* which means this probably isn't needed, but I'm paranoid */
	*SvEND(result_sv) = '\0';
	SvPOK_only(result_sv);
	RETVAL = result_sv;
#line 747 "Collator.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Unicode__ICU__Collator_getLocale); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Unicode__ICU__Collator_getLocale)
{
    dVAR; dXSARGS;
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "col, type = ULOC_ACTUAL_LOCALE");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	Unicode__ICU__Collator	col;
	int	type;
#line 393 "Collator.xs"
       const char *name;
       UErrorCode status = U_ZERO_ERROR;
#line 769 "Collator.c"

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Unicode::ICU::Collator")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    col = INT2PTR(Unicode__ICU__Collator,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"Unicode::ICU::Collator::getLocale",
			"col", "Unicode::ICU::Collator")
;

	if (items < 2)
	    type = ULOC_ACTUAL_LOCALE;
	else {
	    type = (int)SvIV(ST(1))
;
	}
#line 396 "Collator.xs"
       name = ucol_getLocaleByType(col, type, &status);
       if (!U_SUCCESS(status)) {
         croak("Error getting locale type: %d", (int)status);
       }
       if (name) {
         EXTEND(SP, 1);
	 PUSHs(sv_2mortal(newSVpv(name, 0)));
       }
#line 796 "Collator.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Unicode__ICU__Collator_setAttribute); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Unicode__ICU__Collator_setAttribute)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "col, attr, value");
    {
	Unicode__ICU__Collator	col;
	int	attr = (int)SvIV(ST(1))
;
	int	value = (int)SvIV(ST(2))
;
#line 411 "Collator.xs"
	UErrorCode status = U_ZERO_ERROR;
#line 817 "Collator.c"

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Unicode::ICU::Collator")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    col = INT2PTR(Unicode__ICU__Collator,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"Unicode::ICU::Collator::setAttribute",
			"col", "Unicode::ICU::Collator")
;
#line 413 "Collator.xs"
	ucol_setAttribute(col, attr, value, &status);
	if (!U_SUCCESS(status))
	    croak("Error setting attribute: %d", (int)status);
#line 832 "Collator.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Unicode__ICU__Collator_getAttribute); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Unicode__ICU__Collator_getAttribute)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "col, attr");
    {
	Unicode__ICU__Collator	col;
	int	attr = (int)SvIV(ST(1))
;
#line 422 "Collator.xs"
	UErrorCode status = U_ZERO_ERROR;
#line 850 "Collator.c"
	int	RETVAL;
	dXSTARG;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Unicode::ICU::Collator")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    col = INT2PTR(Unicode__ICU__Collator,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"Unicode::ICU::Collator::getAttribute",
			"col", "Unicode::ICU::Collator")
;
#line 424 "Collator.xs"
	RETVAL = ucol_getAttribute(col, attr, &status);
	if (!U_SUCCESS(status))
	    croak("Error setting attribute: %d", (int)status);
#line 867 "Collator.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Unicode__ICU__Collator_getRules); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Unicode__ICU__Collator_getRules)
{
    dVAR; dXSARGS;
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "col, rule_option = UCOL_FULL_RULES");
    {
	Unicode__ICU__Collator	col;
	int	rule_option;
#line 436 "Collator.xs"
        SV *work_sv;
	UChar *work;
        int32_t len;
#line 887 "Collator.c"
	SV *	RETVAL;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Unicode::ICU::Collator")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    col = INT2PTR(Unicode__ICU__Collator,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"Unicode::ICU::Collator::getRules",
			"col", "Unicode::ICU::Collator")
;

	if (items < 2)
	    rule_option = UCOL_FULL_RULES;
	else {
	    rule_option = (int)SvIV(ST(1))
;
	}
#line 440 "Collator.xs"
        /* preflight to get the size */
	len = ucol_getRulesEx(col, rule_option, NULL, 0);
        if (len) {
	  work_sv = sv_2mortal(newSV((len + 1) * sizeof(UChar)));
	  work = (UChar *)SvPVX(work_sv);
	  ucol_getRulesEx(col, rule_option, work, len+1);
	  RETVAL = from_uchar(aTHX_ work, len);
	}
	else {
	  /* no rules */
	  RETVAL = newSVpvn("", 0);
	}
#line 919 "Collator.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Unicode__ICU__Collator_getVersion); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Unicode__ICU__Collator_getVersion)
{
    dVAR; dXSARGS;
    dXSI32;
    if (items != 1)
       croak_xs_usage(cv,  "col");
    {
	Unicode__ICU__Collator	col;
#line 462 "Collator.xs"
        char ver_str[U_MAX_VERSION_STRING_LENGTH];
        UVersionInfo ver;
#line 939 "Collator.c"
	const char *	RETVAL;
	dXSTARG;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Unicode::ICU::Collator")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    col = INT2PTR(Unicode__ICU__Collator,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			GvNAME(CvGV(cv)),
			"col", "Unicode::ICU::Collator")
;
#line 465 "Collator.xs"
	if (ix == 1)
	  ucol_getVersion(col, ver);
 	else
	  ucol_getUCAVersion(col, ver);
	u_versionToString(ver, ver_str);
        RETVAL = ver_str;
#line 959 "Collator.c"
	sv_setpv(TARG, RETVAL); XSprePUSH; PUSHTARG;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Unicode__ICU__Collator_getDisplayName); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Unicode__ICU__Collator_getDisplayName)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "class, locale, disp_loc");
    {
	const char *	locale = (const char *)SvPV_nolen(ST(1))
;
	const char *	disp_loc = (const char *)SvPV_nolen(ST(2))
;
#line 479 "Collator.xs"
        SV *work_sv;
	UChar *work;
        int32_t len;
	UErrorCode status = U_ZERO_ERROR;
	char temp[1];
#line 983 "Collator.c"
	SV *	RETVAL;
#line 485 "Collator.xs"
        /* preflight to get the size */
	len = ucol_getDisplayName(locale, disp_loc, NULL, 0, &status);
	if(status != U_BUFFER_OVERFLOW_ERROR){
	  croak("Unexpected getDisplayName result: %d", (int)status);
	}
	work_sv = sv_2mortal(newSV((len + 1) * sizeof(UChar)));
	work = (UChar *)SvPVX(work_sv);
	status = U_ZERO_ERROR;
	ucol_getDisplayName(locale, disp_loc, work, len+1, &status);
	RETVAL = from_uchar(aTHX_ work, len);
#line 996 "Collator.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Unicode__ICU__Collator_available); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Unicode__ICU__Collator_available)
{
    dVAR; dXSARGS;
    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(items); /* -W */
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
#line 501 "Collator.xs"
	int32_t count;
        int32_t i;
#line 1016 "Collator.c"
#line 504 "Collator.xs"
        count = ucol_countAvailable();
       	EXTEND(SP, count);
        for (i = 0; i < count; ++i) {
          const char *name = ucol_getAvailable(i);
	  PUSHs(sv_2mortal(newSVpv(name, 0)));
        }
#line 1024 "Collator.c"
	PUTBACK;
	return;
    }
}


/* INCLUDE:  Including 'const-xs.inc' from 'Collator.xs' */


XS_EUPXS(XS_Unicode__ICU__Collator_constant); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Unicode__ICU__Collator_constant)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "sv");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
#line 4 "./const-xs.inc"
#ifdef dXSTARG
	dXSTARG; /* Faster if we have it.  */
#else
	dTARGET;
#endif
	STRLEN		len;
        int		type;
	IV		iv = 0; /* avoid uninit var warning */
	/* NV		nv;	Uncomment this if you need to return NVs */
	/* const char	*pv;	Uncomment this if you need to return PVs */
#line 1054 "Collator.c"
	SV *	sv = ST(0)
;
	const char *	s = SvPV(sv, len);
#line 18 "./const-xs.inc"
        /* Change this to constant(aTHX_ s, len, &iv, &nv);
           if you need to return both NVs and IVs */
	type = constant(aTHX_ s, len, &iv);
      /* Return 1 or 2 items. First is error message, or undef if no error.
           Second, if present, is found value */
        switch (type) {
        case PERL_constant_NOTFOUND:
          sv =
	    sv_2mortal(newSVpvf("%s is not a valid Unicode::ICU::Collator macro", s));
          PUSHs(sv);
          break;
        case PERL_constant_NOTDEF:
          sv = sv_2mortal(newSVpvf(
	    "Your vendor has not defined Unicode::ICU::Collator macro %s, used",
				   s));
          PUSHs(sv);
          break;
        case PERL_constant_ISIV:
          EXTEND(SP, 2);
          PUSHs(&PL_sv_undef);
          PUSHi(iv);
          break;
	/* Uncomment this if you need to return NOs
        case PERL_constant_ISNO:
          EXTEND(SP, 2);
          PUSHs(&PL_sv_undef);
          PUSHs(&PL_sv_no);
          break; */
	/* Uncomment this if you need to return NVs
        case PERL_constant_ISNV:
          EXTEND(SP, 2);
          PUSHs(&PL_sv_undef);
          PUSHn(nv);
          break; */
	/* Uncomment this if you need to return PVs
        case PERL_constant_ISPV:
          EXTEND(SP, 2);
          PUSHs(&PL_sv_undef);
          PUSHp(pv, strlen(pv));
          break; */
	/* Uncomment this if you need to return PVNs
        case PERL_constant_ISPVN:
          EXTEND(SP, 2);
          PUSHs(&PL_sv_undef);
          PUSHp(pv, iv);
          break; */
	/* Uncomment this if you need to return SVs
        case PERL_constant_ISSV:
          EXTEND(SP, 2);
          PUSHs(&PL_sv_undef);
          PUSHs(sv);
          break; */
	/* Uncomment this if you need to return UNDEFs
        case PERL_constant_ISUNDEF:
          break; */
	/* Uncomment this if you need to return UVs
        case PERL_constant_ISUV:
          EXTEND(SP, 2);
          PUSHs(&PL_sv_undef);
          PUSHu((UV)iv);
          break; */
	/* Uncomment this if you need to return YESs
        case PERL_constant_ISYES:
          EXTEND(SP, 2);
          PUSHs(&PL_sv_undef);
          PUSHs(&PL_sv_yes);
          break; */
        default:
          sv = sv_2mortal(newSVpvf(
	    "Unexpected return type %d while processing Unicode::ICU::Collator macro %s, used",
               type, s));
          PUSHs(sv);
        }
#line 1132 "Collator.c"
	PUTBACK;
	return;
    }
}


/* INCLUDE: Returning to 'Collator.xs' from 'const-xs.inc' */

#ifdef __cplusplus
extern "C"
#endif
XS_EXTERNAL(boot_Unicode__ICU__Collator); /* prototype to pass -Wmissing-prototypes */
XS_EXTERNAL(boot_Unicode__ICU__Collator)
{
#if PERL_VERSION_LE(5, 21, 5)
    dVAR; dXSARGS;
#else
    dVAR; dXSBOOTARGSXSAPIVERCHK;
#endif
#if (PERL_REVISION == 5 && PERL_VERSION < 9)
    char* file = __FILE__;
#else
    const char* file = __FILE__;
#endif

    PERL_UNUSED_VAR(file);

    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(items); /* -W */
#if PERL_VERSION_LE(5, 21, 5)
    XS_VERSION_BOOTCHECK;
#  ifdef XS_APIVERSION_BOOTCHECK
    XS_APIVERSION_BOOTCHECK;
#  endif
#endif

        newXS_deffile("Unicode::ICU::Collator::new", XS_Unicode__ICU__Collator_new);
        newXS_deffile("Unicode::ICU::Collator::DESTROY", XS_Unicode__ICU__Collator_DESTROY);
        newXS_deffile("Unicode::ICU::Collator::cmp", XS_Unicode__ICU__Collator_cmp);
        newXS_deffile("Unicode::ICU::Collator::eq", XS_Unicode__ICU__Collator_eq);
        newXS_deffile("Unicode::ICU::Collator::ne", XS_Unicode__ICU__Collator_ne);
        newXS_deffile("Unicode::ICU::Collator::gt", XS_Unicode__ICU__Collator_gt);
        newXS_deffile("Unicode::ICU::Collator::lt", XS_Unicode__ICU__Collator_lt);
        newXS_deffile("Unicode::ICU::Collator::ge", XS_Unicode__ICU__Collator_ge);
        newXS_deffile("Unicode::ICU::Collator::le", XS_Unicode__ICU__Collator_le);
        newXS_deffile("Unicode::ICU::Collator::getSortKey", XS_Unicode__ICU__Collator_getSortKey);
        newXS_deffile("Unicode::ICU::Collator::getLocale", XS_Unicode__ICU__Collator_getLocale);
        newXS_deffile("Unicode::ICU::Collator::setAttribute", XS_Unicode__ICU__Collator_setAttribute);
        newXS_deffile("Unicode::ICU::Collator::getAttribute", XS_Unicode__ICU__Collator_getAttribute);
        newXS_deffile("Unicode::ICU::Collator::getRules", XS_Unicode__ICU__Collator_getRules);
        cv = newXS_deffile("Unicode::ICU::Collator::getUCAVersion", XS_Unicode__ICU__Collator_getVersion);
        XSANY.any_i32 = 2;
        cv = newXS_deffile("Unicode::ICU::Collator::getVersion", XS_Unicode__ICU__Collator_getVersion);
        XSANY.any_i32 = 1;
        newXS_deffile("Unicode::ICU::Collator::getDisplayName", XS_Unicode__ICU__Collator_getDisplayName);
        newXS_deffile("Unicode::ICU::Collator::available", XS_Unicode__ICU__Collator_available);
        newXS_deffile("Unicode::ICU::Collator::constant", XS_Unicode__ICU__Collator_constant);
#if PERL_VERSION_LE(5, 21, 5)
#  if PERL_VERSION_GE(5, 9, 0)
    if (PL_unitcheckav)
        call_list(PL_scopestack_ix, PL_unitcheckav);
#  endif
    XSRETURN_YES;
#else
    Perl_xs_boot_epilog(aTHX_ ax);
#endif
}

